/*******************************************************************************
 * Copyright (c) 2015-2018 Skymind, Inc.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Apache License, Version 2.0 which is available at
 * https://www.apache.org/licenses/LICENSE-2.0.
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations
 * under the License.
 *
 * SPDX-License-Identifier: Apache-2.0
 ******************************************************************************/

package org.nd4j.linalg.api.ops.impl.shape.tensorops;

import org.nd4j.autodiff.samediff.SDVariable;
import org.nd4j.autodiff.samediff.SameDiff;
import org.nd4j.linalg.api.buffer.DataType;
import org.nd4j.linalg.api.ops.Op;

import java.util.Collections;
import java.util.List;

public class TensorArrayWrite extends BaseTensorOp {

   public TensorArrayWrite(String name, SameDiff sameDiff, SDVariable[] args){
      super(name, sameDiff, args);
   }
   public TensorArrayWrite(SameDiff sameDiff, SDVariable[] args){
      super(null, sameDiff, args);
   }

   public TensorArrayWrite(){}
   @Override
   public String tensorflowName() {
      return "TensorArrayWriteV3";
   }

   @Override
   public String opName() {
      return "tensorarraywritev3";
   }

   @Override
   public Op.Type opType() {
      return Op.Type.CUSTOM;
   }

    @Override
    public List<DataType> calculateOutputDataTypes(List<DataType> inputDataType){
        //Dummy float variable
        return Collections.singletonList(DataType.FLOAT);
    }
}
